/******************************************************
** qLCR is written by cubical <cubical@users.sourceforge.net>
** requirements: wvdial, wget, qt, ntpdate, bunzip2, sysfs (/sys)                    
** published under the terms of the General Public License (GPL)                     
** check README for further information.     
*******************************************************/

//#define DODEBUG
//#define PPPAGENT

#include <qdom.h>
#include <qfile.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <qlistview.h>
#include <qprocess.h> 
#include <qdatetime.h>
#include <qtimer.h>
#include <qfileinfo.h> 
#include <qregexp.h>
#include <unistd.h>

static QString version="0.4.1";
static QString startmsg="written by cubical - www.thepingofdeath.de";

static QString wvdialbin="wvdial";
static QString wgetbin="wget";
static QString ntpbin="ntpdate";
static QString unzipbin="bunzip2";
//static QString psbin="ps";
static QString pingbin="ping";

static QString sysdir="/etc/qlcr/";
static QString confdir=QDir::homeDirPath()+"/.qlcr/";
static QString wvdialconf=confdir+"wvdial.conf";
static QString wvdialconftempl=confdir+"wvdial.template";
static QString providerfileshort="provider.xml";
static QString providerfile=confdir+providerfileshort;
static QString providerdlfile=confdir+"provider.xml.bz2";
static QString configfile=confdir+"qlcr.conf";
static QString logfile=confdir+"qlcr.log";
static QString debugfile=confdir+"debug.log";
static QString connectionfile=confdir+"connections.xml";
static QString connectionoutputfile=confdir+"connections.html";
static QString providerfileurl="http://zippedprovider.webhop.org";

static QString unknown="???";

QString RXFile;
QString TXFile;
QString oldstatus;

QProcess *wvdial;
QProcess *wget;  
QProcess *ntpdate;  
QProcess *starter;  
QProcess *unzip;  
//QProcess *ps;  
QProcess *ping;  

QTime OnTime (0,0,0,90);
QString dialedname="nicht verbunden";
QString dialedcost;
QString dialednumber;
QString iface="ppp0";
QString status="offline";
QString bps=unknown;
QString ip=unknown;
float allcost=0;
float dialincost;
bool dialedin=false;
bool isonline=false;
bool realonline=false;
bool list_checked=false;
bool time_set=false;
bool warned=false;
bool isredir=false;
bool dodisc=false;
bool nodialtone=false;
bool busy=false;
int lday=QDate::currentDate().dayOfWeek();
int  lhour=QTime::currentTime().hour();
long unsigned int ditime;
long unsigned int lastrx,lasttx; 


void LCR::init()
{
    LOG("qLCR "+version+" "+startmsg);    
    
    // some gui finetunig?!
    this -> setCaption("qLCR - "+status);
    this->setFixedSize ( this->width(),this->height()); 
    Provider -> setResizeMode(QListView::NoColumn);
    Provider -> setColumnWidthMode(0,QListView::Manual);
    Provider -> setColumnWidthMode(1,QListView::Manual);
    Provider -> setColumnWidthMode(3,QListView::Manual);
    Provider -> setColumnWidthMode(4,QListView::Manual);
    Provider -> setColumnWidthMode(5,QListView::Manual);
    Provider -> setColumnWidth(0,65);
    Provider -> setColumnWidth(1,65);
    Provider -> setColumnWidth(2,250);
    Provider ->  setColumnWidth(3,0);   
    Provider ->  setColumnWidth(4,0);   
    Provider ->  setColumnWidth(5,0);   
        
    Selection->setButton(0);
    SelectionToggle();
    
// init timer2    
//   QTimer *timer2 = new QTimer( this );
//   connect( timer2, SIGNAL(timeout()), this, SLOT(Timer2()) );
//   timer2->start( 1000, false);    

    
    // init 1sec timer 
    QTimer *timer = new QTimer( this );
    connect( timer, SIGNAL(timeout()), this, SLOT(Timer()) );
    timer->start( 1000, false);    
    
    // init 5sec Timer
    QTimer *longtimer = new QTimer( this );
    connect( longtimer, SIGNAL(timeout()), this, SLOT(LongTimer()) );
    longtimer->start( 1000, false);    
    
    // init processes 
    wvdial = new QProcess( this );
    wvdial->addArgument( wvdialbin );
    wvdial->addArgument( "--config" );
    wvdial->addArgument(wvdialconf);
    wvdial->addArgument( "LCR" );
    connect( wvdial, SIGNAL(readyReadStderr()),this, SLOT(readwvdialFromStdout()) );
    connect( wvdial, SIGNAL(processExited()),this,SLOT(DialDone()));
    
    wget = new QProcess( this );
    wget->addArgument( wgetbin );
    wget->addArgument( "-nv" );
    wget->addArgument( "--tries=1" );
    wget->addArgument( "--wait=2" );
    //wget->addArgument( "--mirror" );
    wget->addArgument( "-O" );
    wget->addArgument( providerdlfile );
    wget->addArgument( providerfileurl );
    connect( wget, SIGNAL(readyReadStderr()),this, SLOT(readwgetFromStdout()) );
    connect( wget, SIGNAL(processExited()),this,SLOT(GetListDone()));
    
    ntpdate = new QProcess( this );
    ntpdate->addArgument( ntpbin );
    ntpdate->addArgument( "-u" );
    ntpdate->addArgument( "-v" );
    ntpdate->addArgument( "tick.fh-augsburg.de" );
    ntpdate->addArgument( "ntp0.rz.uni-karlsruhe.de");
    ntpdate->addArgument( "ntp1.ptb.de" );
    connect( ntpdate, SIGNAL(readyReadStderr()),this, SLOT(readntpFromStdout()) );
    connect( ntpdate, SIGNAL(processExited()),this,SLOT(NTPDone()));
    
    unzip = new QProcess( this );
    unzip->addArgument( unzipbin );
    unzip->addArgument( "--force" );
    unzip->addArgument( "--keep" );
    unzip->addArgument( providerdlfile );
    connect( unzip, SIGNAL(readyReadStderr()),this, SLOT(readunzipFromStdout()) );
    connect( unzip, SIGNAL(processExited()),this,SLOT(UnzipDone()));

    ping = new QProcess( this );
    ping->addArgument( pingbin );
    ping->addArgument("-n" );
    ping->addArgument("-w2" );
    ping->addArgument( "-c1" );
    ping->addArgument( "www.google.de" );
    connect( ping, SIGNAL(readyReadStderr()),this, SLOT(readpingFromStdout()) );
    connect( ping, SIGNAL(processExited()),this,SLOT(PingDone()));

    starter = new QProcess( this );

/*    ps = new QProcess( this );
    ps->addArgument( psbin );
    ps->addArgument( "-no-heading" );
    ps->addArgument( "-C" );
    ps->addArgument( "qlcr"	    );
    ps->addArgument( providerdlfile );
    connect( ps, SIGNAL(readyReadStderr()),this, SLOT(readpsFromStdout()) );
*/
    
    //ps -> start();    
  
    ReadConfig();
    SetPPPDev();
    CheckForFiles();

    
#ifdef DODEBUG
    LOG("Debug Mode aktiv!");
#endif
    
    lday=QDate::currentDate().dayOfWeek();
    lhour=QTime::currentTime().hour();
    ParseXML(lhour,lday);
    
    this ->show();       
}


void LCR::ParseXML(int chour, int cday)
{
   
    while (unzip->isRunning()){sleep(1);}
    
    QString Error;
    Provider -> clear();
    
    if (cday<6){cday=1;}
    else {cday=6;}
    
    if (OldXML() && OldWarn->isChecked()){
    QMessageBox::critical( this, "Warnung",providerfileshort+" ist alt und sollte aktualisiert werden.");
    }
    
    // read xml file to memory
    QDomDocument doc("Provider");
    QFile file( providerfile );
    if( !file.open( IO_ReadOnly ) ){
 LOG(providerfile+" nicht lesbar");
 return;}
    if( !doc.setContent( &file ) ){
 file.close();
 LOG("Fehler beim Parsen von "+providerfile);
 return;
    }
    file.close(); 
    
    // try to find root element 
    QDomElement root = doc.documentElement();
    if( root.tagName() != "provider-list" ){
 LOG(providerfile+" fehlerhaft");
 return;
    }
    //parse    the tree & read in provider critical
    
    QDomNode n = root.firstChild();
    while( !n.isNull() ){
 QDomElement e = n.toElement();
 if( !e.isNull() ){
     if( e.tagName() == "timeslot" ){
  if ((e.attribute("hour","").toInt()==chour) && (e.attribute("day","").toInt()==cday)){
      QDomNode p = n.firstChild();
      bool found=false;
      while(!p.isNull()){
   QDomElement i = p.toElement();
   if (!i.isNull()){
       if( i.tagName() == "provider" ){
    if ((!NoEinwahl->isChecked()) || ((NoEinwahl->isChecked()) && (i.attribute( "connection-cost", "") == "0.00") ) ) {
        Provider -> insertItem( new QListViewItem( Provider, 
                i.attribute( "cost", "" ),
                i.attribute( "connection-cost", "" ), 
                i.attribute( "name", "" ), 
                i.attribute( "number", "" ),
                i.attribute( "username", "" ),
                i.attribute( "password", "" ) ) );
        if (dialedin && (dialednumber==i.attribute( "number", "" )))
        {dialedcost=i.attribute( "cost", "");found=true;};        
    }
       }
   }
   p = p.nextSibling();
      }
      if (dialedin && (!found)){
   dialedcost="";
    /*
    switch(QMessageBox::critical( this, "Warnung","Nach erfolgtem Update ist der aktuelle Provider nicht mehr gelistet!","OK","Trennen",0,0,1)){
       
   case 0:
       break;
       
   case 1:
       DialOut();
       break;
   }  */
      }  
  }
     }
 }
 
 n = n.nextSibling();
    }    
    
    Provider -> setSelected(Provider->firstChild(),TRUE);
    Provider -> setCurrentItem(Provider->firstChild());
}



void LCR::DialIn()
{
    QString cost,name,number,password,username,dcost;
    QListViewItem *item = Provider->currentItem();
    if (item){
 cost=item->text(0);
 dcost=item->text(1);
 name=item->text(2);
 number=item->text(3);
 username=item->text(4);
 password=item->text(5);
    }
    
    dialednumber=number;
    dialedname=name;
    dialedcost=cost;
    dialincost=dcost.toFloat();   
    LOG( "Verbinde mit "+dialedname+" ("+dialednumber+")..."); 
    
    QRegExp wv("(Username|Password|Phone|Dialer LCR|Dialer Defaults|Modem|Init1|Init2|Init3|Baud|Dial Prefix|Dial Command)");
    
    QStringList lines;
    //lines+="[Dialer Defaults]";
    lines+="Modem = "+ModemDevice->text();
    lines+="Baud = "+ModemBaud->text();
    lines+="Dial Command = "+DialString->text();
    lines+="Dial Prefix = "+DialPrefix->text();
    lines+="Init1 = "+ModemInit1->text();
    lines+="Init2 = "+ModemInit2->text();
    QString tmpstr;
    tmpstr=tmpstr.setNum(ModemVolume->value());
    if (ModemVolume->value()==0){
 lines+="Init3 = ATM0L"+tmpstr;
    }
    else {
 lines+="Init3 = ATM1L"+tmpstr;
    }
    
    //read template config  file
    QFile templ( wvdialconftempl );
    if ( templ.open( IO_ReadOnly ) ) {
 QTextStream templstream( &templ);
 QString line;
 while ( !templstream.atEnd() ) {
     line = templstream.readLine(); 
     
     if ((wv.search(line)==-1) && line){
  lines += line;
     }
 }
 templ.close();
 
// ppp-agent support
#ifdef PPPAGENT
 QString ipparam;
 ipparam="qlcr-"+dialedname.lower();
 QRegExp tmp1("\\s");
 QRegExp tmp2("[^a-z,0-9,-]");
 ipparam.replace(tmp1,"-");
 ipparam.replace(tmp2,"");
 lines+="\"PPPD Option\" = \"ipparam "+ipparam+"\"";
#endif
 
 lines+="";
 lines+="[Dialer LCR]";
 lines+="Phone="+number;
 lines+="Username="+username;
 lines+="Password="+password;
 
 //write confile 
 QFile conffile( wvdialconf );
 if ( conffile.open( IO_WriteOnly ) ) {
     QTextStream confstream( &conffile );
     for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
  confstream << *it << "\n";
     conffile.close();
 }
 
 else{
     LOG( "Fehler beim Schreiben von "+wvdialconf );
     return;
 }
    }
    
    else{
 LOG("Fehler beim Lesen von "+wvdialconftempl);
 return;
    }
    
    //run wvdial
    QString Command;
    Command = wvdial->arguments().join(" ");
    DEBUG("qlcr",Command);
     if ( !wvdial->start() ) {
 LOG( "Fehler beim Ausfuehren von "+wvdialbin);
 dialedin=false;
 Einwahl->setEnabled(true);
 Trennen->setEnabled(false);
 return;
    } 
    Einwahl->setEnabled(false);
    Trennen->setEnabled(true);
    allcost=dialincost/100;
    dialedin=true;
    QDateTime now;
    now=QDateTime::currentDateTime();
    ditime=now.toTime_t();
}


void LCR::readwvdialFromStdout()
{
    QString output=wvdial->readStderr();    
    DEBUG(wvdialbin,output );
    QRegExp finddial("ATD");
    QRegExp findonline("CONNECT");
    QRegExp findiface("Using interface");
    QRegExp findip("local\\s*IP address");
    QRegExp finddisc("Disconnecting at");
    QRegExp findDT("NO DIALTONE");
    QRegExp findbusy("BUSY");

    
    //Connecting
    if (finddial.search(output)!=-1){status="verbinden";}
    
    //no dialtone
    if (findDT.search(output)!=-1){nodialtone=true;}
    //busy
    if (findbusy.search(output)!=-1){busy=true;}
    
    // connected
    if (findonline.search(output)!=-1){
 QRegExp tmp1(".*CONNECT ");
 QRegExp tmp2("(/.*|-.*|\\s.*)");
 QRegExp tmp3("\\D");
 output.replace(tmp1,"");
 output.replace(tmp2,"");
 output.replace(tmp3,"");
 LOG("Verbunden mit "+output+" bps");
 bps=output;
 status="einloggen";
    }
    
    // PPP Interface
    if (findiface.search(output)!=-1){       
 QRegExp tmp1(".*Using interface ");
 QRegExp tmp2("\\n.*");
 output.replace(tmp1,"");
 output.replace(tmp2,"");
 iface=output;
 LOG("PPP-Device: "+iface);
 SetPPPDev();
    }
    
    // IP adress
    if (findip.search(output)!=-1){
 QRegExp tmp1("\\n.*");
 QRegExp tmp2("\\s");
 QRegExp tmp3("[a-z,A-Z]|-|>");
 output.replace(tmp1,"");       
 output.replace(tmp2,"");
 output.replace(tmp3,"");       
 LOG("IP: "+output);
 ip=output;
 //status="online";
 isonline=true;
 
}
    
    // Disconnecting
    if (finddisc.search(output)!=-1){status="trennen";isonline=false;realonline=false;}
    
    
}

// read stdout from wget
void LCR::readwgetFromStdout()
{
    QString output=wget->readStderr();
    DEBUG(wgetbin,output);
    QRegExp find("/provider.xml.bz2\\s.*provider.xml.bz2");
    
    if (find.search(output)==-1){
     LOG ("Redirect erkannt! Starte erneuten Versuch");
     isredir=true;
    }
    
}

// Get Provider List
void LCR::GetList()
{
    LOG( "Aktualisiere "+providerfileshort+"...");
    
    //run wget
    QString Command;
    Command = wget->arguments().join(" ");
    DEBUG("qlcr",Command);
    if ( !wget->start() ) {
 LOG( "Fehler beim Ausfuehren von "+wgetbin);
 return;
    }
    
    list_checked=true;    
}


void LCR::Online()
{
    
// if offline  
 if (!wvdial->isRunning()){ 
 status="offline";
 dodisc=false;
 bps=unknown;
 ip=unknown;
 OnTime.setHMS(0,0,0,0);
 list_checked=false;
 time_set=false;
 nodialtone=false;
 busy=false;
    }
    
// if online!
 else {
 
 SetTimer(); 
 
 if ((isonline) && (!realonline))
    if (!ping->isRunning()) 
	{
                QString Command;
	  Command = ping->arguments().join(" ");
                DEBUG("qlcr",Command);
                ping->start();
	 }

 if (realonline){ 
    if ((!time_set)  && (NTP -> isChecked())) {SetTime();}
    if ((!list_checked)  && (AutoUpdate -> isChecked())) {GetList();}
 }
}
    
    if (isredir){
 isredir=false;
 GetList();
    }
    
}



void LCR::DialOut()
{
    if (wvdial->isRunning()){
 dodisc=true;
 wvdial->tryTerminate();
 QTimer::singleShot( 5000, wvdial, SLOT( kill() ) );
    }
    
}

void LCR::destroy()
{
    if (dialedname!="nicht verbunden"){
 WriteConnection();
    }
    DialOut();
    WriteConfig();
}


void LCR::Timer()
{
    SetRXTX();
    Online();  
    
    OnTimer->setText(OnTime.toString(Qt::TextDate));    
    ProviderName->setTitle("Verbindung: "+dialedname);
    
    Status -> setText (status);
    BPS -> setText(bps);
    IP->setText(ip);
    
    if ((status == "offline") || (status == "trennen")) {
 this -> setCaption("qLCR - "+status); }
    else {
 this -> setCaption("qLCR - "+status+" ("+dialedname+")"); }
    
    
    if (dialedcost!=""){
 ProviderKosten->setText(dialedcost);
    }
    else {
 ProviderKosten->setText(unknown);
    }    
    
    if (allcost>0){
 QString tmp; 
 tmp=tmp.setNum(allcost,'f',2);
 GesamtKosten->setText(tmp);
    }
    else{
 GesamtKosten->setText(unknown);
    }    
}



void LCR::LongTimer()
{
    //action on hour or daychange
    if ((lday != QDate::currentDate().dayOfWeek()) || (lhour != QTime::currentTime().hour())){
 lday=QDate::currentDate().dayOfWeek();
 lhour=QTime::currentTime().hour();
 ParseXML(lhour,lday);
 warned=false;
    } 
    
    // warn if provider changes its connection costs
    if (dialedin && (QTime::currentTime().minute()>57)) {
 QString Error;
 int chour=lhour,cday=lday;
 if (chour==23){
     chour=0;
     if (cday==7)
  cday=1;
     else 
  cday++;
 }
 else
     chour++;
 
 if (cday<6){cday=1;}
 else {cday=6;}
 
 
 // read xml file to memory
 QDomDocument doc("Provider");
 QFile file( providerfile );
 if( !file.open( IO_ReadOnly ) ){
     LOG(providerfile+" nicht lesbar");
     return;}
 if( !doc.setContent( &file ) ){
     file.close();
     LOG("Fehler beim Parsen von "+providerfile);
     return;
 }
 file.close(); 
 
 // try to find root element 
 QDomElement root = doc.documentElement();
 if( root.tagName() != "provider-list" ){
     LOG(providerfile+" fehlerhaft");  
     return;
 }
 //parse the tree & read in provider   
 QDomNode n = root.firstChild();
 while( !n.isNull() ){
     QDomElement e = n.toElement();
     if( !e.isNull() ){
  if( e.tagName() == "timeslot" ){
      if ((e.attribute("hour","").toInt()==chour) && (e.attribute("day","").toInt()==cday)){
   QDomNode p = n.firstChild();
   while(!p.isNull()){
       QDomElement i = p.toElement();
       if (!i.isNull()){
    if( i.tagName() == "provider" ){
        if (i.attribute("number","")==dialednumber){
     if(i.attribute("cost","")!=dialedcost){
         if (!warned && (DoWarn->isChecked())){
      warned=true;
      Warning("Naechste Stunde aendern sich die Kosten von "+dialedcost+" c/min auf "+i.attribute("cost","")+ " c/min.");}
         if ((QTime::currentTime().minute()==59) && (QTime::currentTime().second()>40) && (AutoDisc->isChecked()) && (dialedcost.toFloat()<i.attribute("cost","").toFloat()) &&  (!dodisc) ) {
      LOG("Trenne Verbindung (Kostenaenderung!)");
      DialOut();}
         return;
     }
     return;
        }
    }
       }
       p = p.nextSibling();
   }
      }
  }
     }
     
     n = n.nextSibling();
 }
 
 if (!warned && (DoWarn->isChecked())){
     warned=true;
     Warning("Naechste Stunde steigen die Kosten wahrscheinlich wesentlich!");
 }
 
 if ((QTime::currentTime().minute()==59) && (QTime::currentTime().second()>40) && (AutoDisc->isChecked()) && (!dodisc) ){
     LOG("Trenne Verbindung (Kostenaenderung!)");
     DialOut();
 }   
 
    }    
}


int LCR::OldXML()
{
    QFileInfo fi ( providerfile );
    
    if (fi.exists()) {
 if (((QDateTime::currentDateTime().toTime_t()) - (fi.lastModified().toTime_t())) > 600000){
     LastUpdate->setText("<qt text=red>"+fi.lastModified().toString(Qt::LocalDate)+"</qt>");
     return 1;
 }
 else {
     LastUpdate->setText("<qt text=black>"+fi.lastModified().toString(Qt::LocalDate)+"</qt>");
 }
    }
    
    return 0;
}


void LCR::GetListDone()
{
#ifdef DODEBUG
QString tmpstr;
tmpstr=tmpstr.setNum(wget->exitStatus());
LOG(wgetbin+": Exit-Code: "+tmpstr);
#endif 
    
    if (wget->exitStatus()!=0){
 QString tmpstr;
 tmpstr=tmpstr.setNum(wget->exitStatus());
 LOG("Fehler beim Download von "+providerfileshort+" (Exit-Code: "+tmpstr+")");
    }
    else{
 
 if (!isredir) {
     //QFileInfo fi( providerdlfile );
     //QDir prov( providerdlfile );
     //prov.rename( providerdlfile, providerfile);
     Unzip();
     lday=QDate::currentDate().dayOfWeek();
     lhour=QTime::currentTime().hour();
     LOG(providerfileshort+" aktualisiert");
     ParseXML(lhour,lday);
 }
    }
}


void LCR::DialDone()
{
#ifdef DODEBUG
QString tmpstr;
tmpstr=tmpstr.setNum(wvdial->exitStatus());
LOG(wvdialbin+": Exit-Code: "+tmpstr);
#endif 

    if ((wvdial->normalExit()) && (wvdial->exitStatus()==1)){
 if (busy){LOG("Die Leitung ist besetzt!");}
 else{ 
     if (nodialtone) {LOG("Kein Freizeichen!");}
     else{LOG("Verbindung zu "+ dialedname +" getrennt (Dauer: "+OnTime.toString(Qt::TextDate)+")");}
 }    
    }
    else{
 QString tmpstr;
 tmpstr=tmpstr.setNum(unzip->exitStatus());
 LOG("Verbindung zu "+ dialedname +" unterbrochen (Dauer: "+OnTime.toString(Qt::TextDate)+")");
    }
    
    WriteConnection();
    dialednumber="";
    dialedcost="";
    dialedname="nicht verbunden";
    dialedin=false; 
    Einwahl->setEnabled(true);
    Trennen->setEnabled(false);
}


void LCR::CheckForFiles()
{
 
 QDir d(confdir); 
 if ( !d.exists() )
	d.QDir::mkdir(confdir,TRUE);
 
 //template file
 QFile templ( wvdialconftempl );
    if ( !templ.exists() )
    {
	QStringList lines;
	lines+="Auto Reconnect = OFF";
	lines+="Abort On Busy = ON";
	lines+="Dial Attempts = 1";
	lines+="Stupid Mode = 1";
 
	if ( templ.open( IO_WriteOnly ) ) 
	{
	    QTextStream confstream( &templ);
	    for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
		confstream << *it << "\n";
	    templ.close();
	}
	
	else
	    LOG("Fehler beim Erstellen von "+wvdialconftempl);
    }
    
 // provider.xml file   
 
    
 QFile provider(providerfile);
 if (!provider.exists())
    {
      QStringList providerlines;
      QFile tmp( sysdir+providerfileshort );
      if ( tmp.open( IO_ReadOnly ) ) 
      {
	QTextStream tmpstream( &tmp);
	QString line;
	while ( !tmpstream.atEnd() ) {
	    line = tmpstream.readLine(); 
	    providerlines += line;
	}
      tmp.close();
     
           if (provider.open( IO_WriteOnly ))
          {	 
	       QTextStream confstream( &provider);
	       for ( QStringList::Iterator it = providerlines.begin(); it != providerlines.end(); ++it )
		   confstream << *it << "\n";
	       provider.close();
	       
             LOG("Die Basis-Providerliste wurde geladen!");
             LOG("Nach Einwahl und Aktualisierung steht die volle Liste bereit.");
          
           }  
 
          else
          {
	  LOG("Fehler beim Erstellen von "+providerfileshort);
          }   
     }
      
      else
      {
	  LOG("Fehler beim Lesen von "+sysdir+providerfileshort);
      }   
  }
 
if (!AppendLog->isChecked())
   {
	QFile lfile ( logfile );
	QFile dfile ( debugfile );
 
      if ( lfile.open(IO_WriteOnly) ) {
	lfile.remove();
      }
 
      if ( dfile.open(IO_WriteOnly) ) {
	  dfile.remove();
      }
  }
}


void LCR::SetTimer()
{
    if (OnTime.second()==0)
    {allcost=allcost+(dialedcost.toFloat()/100);}
    QTime Temp=OnTime;
    OnTime= Temp.addSecs(1);
}


void LCR::SetRXTX()
{
    unsigned long int rx,tx;
    QRegExp regexp( "\\n" ); 
    
    
    {
 float rxs;
 QFile f(RXFile );
 if ( !f.open( IO_ReadOnly ) )
     return;
 QTextStream rxt( &f );
 QString rxtmp;
 rxtmp = rxt.readLine(); 
 rxtmp.replace( regexp, "" );
 rx=rxtmp.toInt();
 rxs=rx-lastrx;
 rxs=rxs/1024;
 lastrx=rx;
 rxtmp=rxtmp.setNum(rxs,'f',1);
 RX->setText(rxtmp);
 f.close();
    }
    
    {
 float txs;
 QFile f(TXFile );
 if ( !f.open( IO_ReadOnly ) )
     return;
 QTextStream txt( &f );
 QString txtmp;
 txtmp = txt.readLine(); 
 txtmp.replace( regexp, "" );
 tx=txtmp.toInt();
 txs=tx-lasttx;
 txs=txs/1024;
 lasttx=tx;
 txtmp=txtmp.setNum(txs,'f',1);
 TX->setText(txtmp);
 f.close();
    }
    
}



void LCR::SetPPPDev()
{
    RXFile="/sys/class/net/"+iface+"/statistics/rx_bytes";
    TXFile="/sys/class/net/"+iface+"/statistics/tx_bytes";
}


void LCR::ToggleNoEinwahl()
{
    ParseXML(lhour,lday);
}


void LCR::ReadConfig()
{
    QRegExp findautoup ("NoAutoUpdate");
    QRegExp findautodisc ("NoAutoDisc");
    QRegExp findnoeinwahl ("NoConnCost");
    QRegExp findnowarn ("NoWarnings");
    QRegExp findhidetray ("HideTray");
    QRegExp findntp ("NoNTP");
    QRegExp findoldwarn ("NoOldWarn");
    
    QRegExp findminimize ("MinimizeOnConnect");
    QRegExp findbrowser ("StartScript");
    QRegExp findwhichbrowser ("RunOnConn:");
    QRegExp findprovbrowser ("Browser:");
    QRegExp finddolog ("DoLog");
    QRegExp findappendlog ("AppendLog");
    
    QRegExp modemdevice ("ModemDevice:");
    QRegExp modembaud ("ModemBaud:");
    QRegExp dialstring ("DialString:");
    QRegExp dialprefix ("DialPrefix:");
    QRegExp init1 ("ModemInit1:");
    QRegExp init2 ("ModemInit2:");
    QRegExp volume ("ModemVolume:");
    
    QFile config( configfile );
    if ( config.open( IO_ReadOnly ) ) {
 QTextStream configstream( &config);
 QString line;
 while ( !configstream.atEnd() ) {
     line = configstream.readLine(); 
     
     if (findautoup.search(line)!=-1){AutoUpdate->setChecked(false);}
     if (findautodisc.search(line)!=-1){AutoDisc->setChecked(false);}
     if (findnoeinwahl.search(line)!=-1){NoEinwahl->setChecked(true);}
     if (findnowarn.search(line)!=-1){DoWarn->setChecked(false);}
     //if (findhidetray.search(line)!=-1){ShowTray->setChecked(false);}
     if (findntp.search(line)!=-1){NTP->setChecked(false);}
     if (findoldwarn.search(line)!=-1){OldWarn->setChecked(false);}
     if (findminimize.search(line)!=-1){Minimize->setChecked(true);}
     if (findbrowser.search(line)!=-1){StartScript->setChecked(true);}
     if (finddolog.search(line)!=-1){DoLog->setChecked(true);}
     if (findappendlog.search(line)!=-1){AppendLog->setChecked(true);}
     
     if (findwhichbrowser.search(line)!=-1){
  QString input=line;
  input.replace(findwhichbrowser,"");       
  RunOnConn->setText(input);
     }    
     
     if (findprovbrowser.search(line)!=-1){
  QString input=line;
  input.replace(findprovbrowser,"");       
  KostenBrowser->setCurrentItem(input.toInt());
     }    
     
     if (modemdevice.search(line)!=-1){
  QString input=line;
  input.replace(modemdevice,"");       
  ModemDevice->setText(input);
     }    
     
     if (modembaud.search(line)!=-1){
  QString input=line;
  input.replace(modembaud,"");       
  ModemBaud->setText(input);
     }    
     
     if (dialstring.search(line)!=-1){
  QString input=line;
  input.replace(dialstring,"");       
  DialString->setText(input);
     }    
     
     if (dialprefix.search(line)!=-1){
  QString input=line;
  input.replace(dialprefix,"");       
  DialPrefix->setText(input);
     }    
     
     if (init1.search(line)!=-1){
  QString input=line;
  input.replace(init1,"");       
  ModemInit1->setText(input);
     }    
     
     if (init2.search(line)!=-1){
  QString input=line;
  input.replace(init2,"");       
  ModemInit2->setText(input);
     }    
     
     if (volume.search(line)!=-1){
  QString input=line;
  input.replace(volume,"");       
  ModemVolume->setValue(input.toInt());
     }    
     
 }
 config.close();
    }
}


void LCR::WriteConfig()
{
    QStringList lines;
    
    if (!AutoUpdate->isChecked()){lines+="NoAutoUpdate";}
    if (!DoWarn->isChecked()){lines+="NoWarnings";}
    //if (!ShowTray->isChecked()){lines+="HideTray";}
    if (!NTP->isChecked()){lines+="NoNTP";}
    if (!OldWarn->isChecked()){lines+="NoOldWarn";}
    
    if (NoEinwahl->isChecked()){lines+="NoConnCost";}
    if (!AutoDisc->isChecked()){lines+="NoAutoDisc";}
    if (Minimize->isChecked()){lines+="MinimizeOnConnect";}
    if (DoLog->isChecked()){lines+="DoLog";}
    if (AppendLog->isChecked()){lines+="AppendLog";}
    if (StartScript->isChecked()){lines+="StartScript";}
    
    
    QString tmp;
    tmp=tmp.setNum(KostenBrowser->currentItem());
    lines+="Browser:"+tmp;
    lines+="RunOnConn:"+RunOnConn->text();
    lines+="ModemDevice:"+ModemDevice->text();
    lines+="ModemBaud:"+ModemBaud->text();
    lines+="DialString:"+DialString->text();
    lines+="DialPrefix:"+DialPrefix->text();
    lines+="ModemInit1:"+ModemInit1->text();
    lines+="ModemInit2:"+ModemInit2->text();
    QString tmpstr;
    tmpstr=tmpstr.setNum(ModemVolume->value());
    lines+="ModemVolume:"+tmpstr;
    
    QFile config( configfile );
    if ( config.open( IO_WriteOnly ) ) {
 QTextStream configstream( &config );
 for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
     configstream << *it << "\n";
 config.close();
    }
}


void LCR::Warning(QString warntext)
{
    switch(QMessageBox::critical( this, "Warnung",warntext,"OK","Trennen",0,0,1)){
 
    case 0:
 break;
 
    case 1:
 DialOut();
 break;
    }
    
}


void LCR::readntpFromStdout()
{
    QString output=ntpdate->readStderr();
    DEBUG(ntpbin,output);
}


void LCR::NTPDone()
{
#ifdef DODEBUG
QString tmpstr;
tmpstr=tmpstr.setNum(ntpdate->exitStatus());
LOG(ntpbin+": Exit-Code: "+tmpstr);
#endif 

    if (ntpdate->exitStatus()==0){
 LOG("Uhrzeit synchronisiert");
    }
    else{
              QString tmpstr;
              tmpstr=tmpstr.setNum(ntpdate->exitStatus());
 LOG("Fehler beim Synchronisieren der Uhrzeit (Exit-Code: "+tmpstr+")");
    }
}



void LCR::SetTime()
{
    LOG( "Synchronisiere Uhrzeit...");  
    QString Command;
    Command = ntpdate->arguments().join(" ");
    DEBUG("qlcr",Command);    
    if ( !ntpdate->start() ) {
 LOG( "Fehler beim Ausfuehren von "+ntpbin);
 return;
    }
    time_set=true;    
}


void LCR::LOG( QString text )
{
    QString tmp;
    tmp=QDateTime::currentDateTime().toString("hh:mm:ss")+" - "+text;
    Log->append(tmp);
    
    if (DoLog->isChecked()){
 LogToFile(logfile,tmp);
    }
}


void LCR::DEBUG( QString prefix, QString text )
{
    QRegExp tmp1("^\\n");
    QRegExp tmp2("\\n\\n");
    QRegExp tmp3("\\n$");
    QRegExp tmp4("\\n");
    
    text.replace(tmp1,"");       
    text.replace(tmp2,"");       
    text.replace(tmp3,"");       
    text.replace(tmp4,"\n"+QDateTime::currentDateTime().toString("hh:mm:ss")+" ("+prefix+") ");       
    
    if (text){  
 QString tmp;
 tmp=QDateTime::currentDateTime().toString("hh:mm:ss")+" ("+prefix+") "+text;
 Debug->append(tmp);
 
 if (DoLog->isChecked()){
 LogToFile(debugfile,tmp);
              }
 
    }
}


void LCR::WriteConnection()
{
    
    
    QStringList lines;
    QDateTime now;
    now=QDateTime::currentDateTime();
    long unsigned int dotime=now.toTime_t();
    
    if ( ((dotime-ditime)>5) && (!nodialtone || !busy)){
 QString dialouttime;
 dialouttime=dialouttime.setNum(dotime);
 QString dialintime;
 dialintime=dialintime.setNum(ditime);
 QString sallcost;
 sallcost=sallcost.setNum(allcost,'f',4);
 
 // read xml file to memory
 QDomDocument doc("connections");
 QFile file( connectionfile );

 file.open( IO_ReadOnly );
 doc.setContent( &file ); 
 file.close(); 
 
 lines+="<connections>";
 
 QDomElement root = doc.documentElement();
 QDomNode n = root.firstChild();
 while( !n.isNull() ){
     QDomElement e = n.toElement();
     if( !e.isNull() ){
  if( e.tagName() == "connection" ){
      lines+="<connection name=\""+e.attribute("name","")+"\" number=\""+e.attribute("number","")+"\" start=\""+e.attribute("start","")+"\" end=\""+e.attribute("end","")+"\" allcost=\""+e.attribute("allcost","")+"\" />";  
  }
  n = n.nextSibling();
     }
 }
 
 
 lines+="<connection name=\""+dialedname+"\" number=\""+dialednumber+"\" start=\""+dialintime+"\" end=\""+dialouttime+"\" allcost=\""+sallcost+"\" />";
 
 lines+="</connections>";
 
 
 QFile conn( connectionfile );
 if ( conn.open(IO_WriteOnly) ) {
     QTextStream confstream( &conn);
     for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
  confstream << *it << "\n";
     conn.close();
 }
 else {
     LOG("Fehler beim Erstellen von "+connectionfile);
 }
 
 ditime=dotime;
    }
}


void LCR::ReadConnections(long unsigned int start, long unsigned int end)
{
    QStringList lines;
    bool altcolor=false;
    float sum=0;
    QDateTime starttime,endtime;
    starttime.setTime_t(start);
    endtime.setTime_t(end);
    QString fromtoString;
    
    if (start==end){
 fromtoString=starttime.toString("dd.MM.yyyy");
    }
    else {
   fromtoString=starttime.toString("dd.MM.yyyy")+" - "+endtime.toString("dd.MM.yyyy");
   }
    
    
    
    lines+="<html><head><title>qLCR - Verbindungs&uuml;bersicht ("+fromtoString+")</title></head>";
    lines+="<body text=#000000 bgcolor=#000000"; // link=#DDDDDD vlink=#999999 alink=#FFFFFF>";
    lines+="<p align=\"center\"><center><h2  style=\"color:#CCCCCC\">Verbindungs&uuml;bersicht ("+fromtoString+")</h2>";
    lines+="<table width=\"80%\"><tr>";
    lines+="<th align=\"left\" width=22% bgcolor=#AAAAAA>Datum</th>";
    lines+="<th align=\"left\" width=30% bgcolor=#AAAAAA>Provider</th>";
    lines+="<th align=\"left\" width=18% bgcolor=#AAAAAA>Nummer</th>";
    lines+="<th align=\"left\" width=15% bgcolor=#AAAAAA>Zeit</th>";
    lines+="<th align=\"left\" width=15% bgcolor=#AAAAAA>Kosten</th></tr>";
    
    
    
    // read xml file to memory
    QDomDocument doc("connections");
    QFile file( connectionfile );
    if( !file.open( IO_ReadOnly ) ){
 LOG(connectionfile+" nicht lesbar");
 return;}
    if( !doc.setContent( &file ) ){
 file.close();
 LOG("Fehler beim Parsen von "+connectionfile);
 return;
    }
    file.close(); 
    
    // try to find root element 
    QDomElement root = doc.documentElement();
    if( root.tagName() != "connections" ){
 LOG(connectionfile+" fehlerhaft");  
 return;
    }
    //parse the tree & read in provider   
    QDomNode n = root.firstChild();
    while( !n.isNull() ){
 QDomElement e = n.toElement();
 if( !e.isNull() ){
     if( e.tagName() == "connection" ){
  if ((e.attribute("start","").toUInt()>=start) && (e.attribute("start","").toUInt()<=(end+86400))){
      QTime conntime;
      QTime temp;
      QDateTime date;
      date.setTime_t(e.attribute("start","").toUInt() );
      conntime=temp.addSecs((e.attribute("end","").toUInt())-(e.attribute("start","").toUInt()));
      
      QString bgcolor;
      if (altcolor){
   altcolor=false;
   bgcolor="#CCCCCC";
      }
      else{
   altcolor=true;
   bgcolor="#EEEEEE";
      }
      
      lines+="<tr bgcolor="+bgcolor+">";
      lines+="<td align=\"left\">"+date.toString(Qt::LocalDate)+"</td>";  
      lines+="<td align=\"left\">"+e.attribute("name","")+"</td>";  
      lines+="<td align=\"left\">"+e.attribute("number","")+"</td>";  
      lines+="<td align=\"left\">"+conntime.toString("hh:mm:ss")+"</td>";  
      lines+="<td align=\"left\">"+e.attribute("allcost","")+" Euro</td>";  
      lines+="</tr>";
      
      sum=sum+e.attribute("allcost","").toFloat();
  }
  n = n.nextSibling();
     }
 }
    }
    
    QString tmp; 
    tmp=tmp.setNum(sum,'f',4);
    lines+="<tr bgcolor=\"#000000\"><td></td><td></td><td></td><td align=\"left\"  bgcolor=\"#BB0000\" style=\"color:#CCCCCC\"><b>Gesamt:</b></td><td align=\"left\" bgcolor=\"#BB0000\"  style=\"color:#CCCCCC\"><b>"+tmp+" Euro</b></td></tr>";    
    lines+="</table><h5 style=\"color:#CCCCCC\">Alle Angaben dienen nur zur Orientierung. Keine Gew&auml;hr!</h5>";
    lines+="</center></p></body></html>";
    
    
    QFile connoutput( connectionoutputfile );
    if ( connoutput.open(IO_WriteOnly) ) {
 QTextStream confstream( &connoutput);
 for ( QStringList::Iterator it = lines.begin(); it != lines.end(); ++it )
     confstream << *it << "\n";
 connoutput.close();
    }
    else {
 LOG("Fehler beim Erstellen von "+connectionoutputfile);
    }
    
}


void LCR::ShowConnections()
{
    QDateTime start,end;
    long unsigned int istart,iend;
    
    start=StartDate->date();
    end=EndDate->date();
    istart=start.toTime_t();
    iend=end.toTime_t();
    
    // swap dates
    if (istart>iend){
    long unsigned tmp;
    tmp=istart;
    istart=iend;
    iend=tmp;
    }
        
    ReadConnections(istart,iend);
    
    QStringList fields;
    
    switch (KostenBrowser->currentItem()){
 
    case 0: fields+="mozilla";
 break;
    case 1: fields+="firefox";
 break;
    case 2: fields+="opera";
 break;
    case 3: fields+="konqueror";
 break;
    case 4: fields+="xterm";
 fields+="-e";
 fields+="lynx";
 break;
    }
    
    fields+=connectionoutputfile;
    starter->clearArguments();
    starter->setArguments( fields );
    starter -> start();
}



void LCR::SelectionToggle()
{
    QDate tmp,tmp2;
    switch(Selection->selectedId()){
    case 0:
 StartDate->setDate(QDate::currentDate());
 EndDate->setDate(QDate::currentDate());
 StartDate->setEnabled(false);
 EndDate->setEnabled(false);
 break;
    case 1:
 tmp=QDate::currentDate();
 tmp2=QDate::currentDate();
 tmp=tmp.addDays(-1);
 tmp2=tmp2.addDays(-1);
 StartDate->setDate(tmp);
 EndDate->setDate(tmp2);
 StartDate->setEnabled(false);
 EndDate->setEnabled(false);
 break;
    case 2:
 tmp=QDate::currentDate();
 if (tmp.dayOfWeek()>1){
     tmp=tmp.addDays(-(tmp.dayOfWeek()-1));
 }
 else {
     if (tmp.dayOfWeek()==0) {
  tmp=tmp.addDays(-6);
     }
 }
 
 StartDate->setDate(tmp);
 EndDate->setDate(QDate::currentDate());
 StartDate->setEnabled(false);
 EndDate->setEnabled(false);
 break;
 
    case 3:
 tmp=QDate::currentDate();
 tmp.setYMD(tmp.year(),tmp.month(),1);
 StartDate->setDate(tmp);
 EndDate->setDate(QDate::currentDate());
 StartDate->setEnabled(false);
 EndDate->setEnabled(false);
 break;
 
    case 4:
 tmp=QDate::currentDate();
 tmp.setYMD(tmp.year(),1,1);
 StartDate->setDate(tmp);
 EndDate->setDate(QDate::currentDate());
 StartDate->setEnabled(false);
 EndDate->setEnabled(false);
 break;
 
    case 5:
 StartDate->setEnabled(true);
 EndDate->setEnabled(true);
 break;
    }
}


void LCR::COWarn()
{
    if (!AutoDisc->isChecked()){
 QMessageBox::critical( this, "Warnung","Bei deaktivierter Autotrennung kann es zu Fehlern in der Kostenrechnung kommen! Siehe FAQ.");
    }
}


void LCR::Unzip()
{
    QString Command;
    Command = unzip->arguments().join(" ");
    DEBUG("qlcr",Command);
    if ( !unzip->start() ) {
 LOG( "Fehler beim Ausfuehren von "+unzipbin);
    } 
}




void LCR::UnzipDone()
{
#ifdef DODEBUG
QString tmpstr;
tmpstr=tmpstr.setNum(unzip->exitStatus());
LOG(unzipbin+": Exit-Code: "+tmpstr);
#endif 
    
    if (unzip->exitStatus()!=0){
 QString tmpstr;
              tmpstr=tmpstr.setNum(unzip->exitStatus());
 LOG("Fehler beim Entpacken von "+providerfileshort+" (Exit-Code: "+tmpstr+")");
    }
}


void LCR::readunzipFromStdout()
{
QString output=unzip->readStderr();
DEBUG(unzipbin,output);
}


void LCR::LogToFile( QString file, QString text )
{

QFile lfile ( file );
    if ( lfile.open(IO_WriteOnly | IO_Append) ) {
 QTextStream confstream( &lfile);
              confstream << text << "\n";   
 lfile.close();
    }
    else {
 LOG("Fehler beim Loggen nach "+file);
    }
}



/*void LCR::readpsFromStdout()
{
QString output=ps->readStderr();

//this->close();
}
*/


void LCR::PingDone()
{
#ifdef DODEBUG
QString tmpstr;
tmpstr=tmpstr.setNum(ping->exitStatus());
LOG(pingbin+": Exit-Code: "+tmpstr);
#endif 
    
if (ping->exitStatus()==0)
 {realonline=true;
  status="online";
  LOG("Online!");
  
  if (Minimize->isChecked()){
       this -> setFocus();
       this -> setActiveWindow();
       this -> showMinimized();
 }
 
 if (StartScript->isChecked()){
     
     QStringList fields=QStringList::split(" ",RunOnConn->text());
     starter->clearArguments();
     starter->setArguments( fields );
     starter-> start();
 }
   
}
}


void LCR::readpingFromStdout()
{
QString output=ping->readStderr();
DEBUG("ping",output);
}


